//----------------------------------------------------------------------------
//
// Some C Objects for Allegro's gui
//
// Initial coding: Douglas Eleveld (D.J.Eleveld@anest.azg.nl) - Feb 1997
//
//----------------------------------------------------------------------------
#ifndef ALLEGRO_GUI_C_OBJECTS
#define ALLEGRO_GUI_C_OBJECTS

//----------------------------------------------------------------------------
#include "allegro.h"

#ifdef __cplusplus
extern "C" {
#endif

//----------------------------------------------------------------------------
// Helper function for dialog to move objects
//
// This dialog object can move other objects in a dialog around
// Put the key code of the key to start the move into the key
// field, and the dialog to move objects from pointed to by dp.
// When you want to move an object press the key from your key code
// with the mouse over the object and then you can move the object.
// Press space or enter or the key again to put the object down.
// Placement granularity goes into field d1.
int object_move_proc (int msg, DIALOG *d, int c);

//----------------------------------------------------------------------------
// Helper function for dialog to resize objects
//
// This dialog object can resize other objects in a dialog around
// Put the key code of the key to start the move into the key
// field, and the dialog to resize objects from pointed to by dp.
// When you want to resize an object press the key from your key code
// with the mouse over the object and then you can resize the object.
// Press space or enter or the key again to put the object down.
// The routine protects you from making objects with width or height
// less than zero by restricting the mouse motion
// Placement granularity goes into field d1
int object_resize_proc (int msg, DIALOG *d, int c);

//----------------------------------------------------------------------------
// Just some helper function for the Allegro object procedures
//----------------------------------------------------------------------------

// Find the smallest object being pointed to in a dialog
DIALOG* find_mouse_object (DIALOG* current);

// Helper function to actually move and resize objects
//
// The object to move goes in pointed and the dialog that contains it
// goes in the d variable. The granularity of the move goes in the
// granularity variable
int do_object_move (DIALOG *pointed, DIALOG* d, const int granularity);
int do_object_resize (DIALOG *pointed, DIALOG *d, const int granularity);

//----------------------------------------------------------------------------
#ifdef __cplusplus
}
#endif
//----------------------------------------------------------------------------
#endif

